import java.util.ArrayList;
import java.util.Objects;

public class User {
    private String name;
    private int score;
    private ArrayList<Card> userCards;

    /**
     * create a user
     */
    public User( String name){
        userCards = new ArrayList<>();
        score = 0;
        this.name = name;
    }

    public User() {

    }

    /**
     * remove a card from user cards
     * @param card
     */
    public void addCard(Card card){
        userCards.add(card);
    }

    /**
     * remove a card from user cards
     * @param card
     */
    public void removeCard(Card card){
        userCards.remove(card);
    }

    /**
     * @return user name
     */
    public String getName() {
        return name;
    }

    /**
     * at the end of the game returns the score of user
     * @return score field
     */
    public int getScore() {
        for (Card card : userCards ){
         score += card.getScore();
        }
        return score;
    }

    public User pass(ArrayList<User> users , User chosenUser){
        return users.get(users.indexOf(chosenUser) + 1);
    }

    public ArrayList<Card> getUserCards() {
        return userCards;
    }

    public void printCards(){
        System.out.println("enter the number of your card for example : 3");
        int counter = 1;
        for (Card card : userCards){
            System.out.println(counter);
            card.print();
            counter++;
        }
        System.out.println(counter+"\n+drawCard");
    }
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof User)) return false;
        User user = (User) o;
        return getScore() == user.getScore() &&
                getName().equals(user.getName()) &&
                userCards.equals(user.userCards);
    }

    @Override
    public int hashCode() {
        return Objects.hash(getName(), getScore(), userCards);
    }
}
